<?php
/*
Plugin Name: Multiple Category Selection Widget
Plugin URI: http://www.zackdesign.biz/mcsw
Description: Select multiple categories at once using this widget!
Author: Isaac Rowntree
Version: 2.3
Author URI: http://zackdesign.biz

    Copyright (c) 2005, 2006 Isaac Rowntree (http://zackdesign.biz)
    QuickShop is released under the GNU General Public
    License (GPL) http://www.gnu.org/licenses/gpl.txt

    This is a WordPress plugin (http://wordpress.org).

*/

$wpmm_cats = 0;
$wpmm_search_vars = 0;

function wpmm_load_category()
{
    if (!empty($_POST['wpmm']))
    {        
        $cats = $_POST['wpmm'];
        
        $sql = '';
          $count = 0;
        foreach ($cats as $cat)
        {
            if ($cat == 0)
                unset($cats[$count]);
            else
                $sql .= $cat.',';
            $count++;
        }
        $sql = trim ($sql, ',');
        if (!empty($sql))
        {
          if (get_option('permalink_structure')!= '')
          {
              wp_redirect(get_bloginfo('url').'/categories/'.$sql.'/search_type/'.$_POST['mmctype'].'/order/'.$_POST['order']);
                  exit();
        }
              else
              {
              wp_redirect(get_bloginfo('url').'/?cat='.$sql.'&search_type='.$_POST['mmctype'].'&order='.$_POST['order']);
                  exit();
          }
        } 
        else if ($_POST['blank'] != 'none') // Blank search
        {
            if (!$_POST['default'])
            {
                if ((get_option('show_on_front') == 'page') && (get_option('page_for_posts')))
                {
                    wp_redirect(get_permalink(get_option('page_for_posts')));
                    exit();
                }
                else
                {
                    wp_redirect(get_bloginfo('url'));
                    exit();
                }
            }
            else
            {
                wp_redirect(get_category_link($_POST['default']));
                exit();
            }
        }
    }
    
   global $wp_rewrite;
   $wp_rewrite->flush_rules();
}


function categories_queryvars( $qvars )
{
  $qvars[] = 'search_type';
  return $qvars;
}

function wpmm_parse($vars)
{
    if (!empty($vars->query_vars['search_type']))
    {
        $cats = explode(',',$vars->query_vars['cat']);
        $type = $vars->query_vars['search_type'];
        $order = $vars->query_vars['order'];
    
        global $wp;
        $wp->set_query_var('category__'.$type, $cats);
        
        if ($order == 'title')
        {
            $wp->set_query_var('orderby', 'title');
            $wp->set_query_var('order', 'asc');
        }
    
        global $wpmm_cats;
        global $wpmm_search_vars;
    
        $wpmm_cats = $vars->query_vars['cat'];
    
        $wpmm_search_vars = $type;
    }
}

function wpmm_add_rewrite_rules( $wp_rewrite ) 
{
  $new_rules = array( 
     'categories/(.+)/search_type/(.+)/order/(.+)/page/(.+)' => 'index.php?cat=' .
       $wp_rewrite->preg_index(1).'&search_type=' . $wp_rewrite->preg_index(2).'&order='.$wp_rewrite->preg_index(3).'&paged='. $wp_rewrite->preg_index(4),
     'categories/(.+)/search_type/(.+)/order/(.+)' => 'index.php?cat=' .
       $wp_rewrite->preg_index(1).'&search_type=' . $wp_rewrite->preg_index(2).'&order='.$wp_rewrite->preg_index(3),
     'categories/(.+)/page/(.+)' => 'index.php?cat=' .
       $wp_rewrite->preg_index(1).'&paged=' . $wp_rewrite->preg_index(2),
     'categories/(.+)' => 'index.php?cat=' .
       $wp_rewrite->preg_index(1));
  
  $wp_rewrite->rules = $new_rules + $wp_rewrite->rules;
}

// Get Wordpress to parse URL for query categories
add_filter('query_vars', 'categories_queryvars' );

// Run the category selection
add_action('parse_request','wpmm_parse');

// Rewrite URL
add_action('init','wpmm_load_category');
add_action('generate_rewrite_rules', 'wpmm_add_rewrite_rules');

add_action('widgets_init', create_function('', 'return register_widget("MCSWwidget");'));

/**
 * wpmm widget Class
 */
class MCSWwidget extends WP_Widget {
    /** constructor */
    function MCSWwidget() {
        parent::WP_Widget(false, $name = 'Multi-Category');	
    }

    /** @see WP_Widget::widget */
    function widget($args, $instance) {	
    
        extract( $args );
        $title = apply_filters('widget_title', $instance['title']);   
        global $wpdb;
        global $wpmm_search_vars;
                                       
        $categories = prepare_categories(get_categories('orderby=name&hide_empty=1&exclude=1,'.$instance['excluded_cats']));
        
        //print_r($instance);
        
        echo $before_widget;
        echo $before_title . $title. $after_title .'
        
        <form action="" method="post" class="wpmcsw">
          <input type="hidden" name="ajax_url" value="'.admin_url('admin-ajax.php').'" id="ajax_url" />
          <input type="hidden" name="ex_cats" value="'.$instance['excluded_cats'].'" id="ex_cats" />
          <input type="hidden" name="default" value="'.$instance['default_category'].'" id="default" />
          <input type="hidden" name="blank" value="'.$instance['blank_search_type'].'" id="blank" />
          <input type="hidden" name="order" value="'.$instance['order'].'" id="order" />
          <input type="hidden" name="mcsw" value="1" id="mcsw" />    
        ';
        
        echo $categories;
        
        $checked1 = '';
        $checked2 = '';
        
        if (!strcmp($wpmm_search_vars, 'and') || !strcmp($instance['def_search_type'], 'and'))
            $checked2 = 'checked="checked"';
        else 
            $checked1 = 'checked="checked"';


        if (!empty($instance['user_choice']))
        {    
            echo '<br />Any <input type="radio" name="mmctype" value="in" '.$checked1.' /> All <input type="radio" name="mmctype" value="and" '.$checked2.' />
            <input type="submit" value="Search" /></form>'.$after_widget;
        }
        else
        { 
            echo '<input type="hidden" name="mmctype" value="'.$instance['def_search_type'].'" />
            <input type="submit" value="Search" /></form>'.$after_widget;
        }
    }

    /** @see WP_Widget::update */
    function update($new_instance, $old_instance) {				
        return $new_instance;
    }

    /** @see WP_Widget::form */
    function form($instance) {				
        if (isset($instance['title'])) : $title = esc_attr($instance['title']); else: $title = ''; endif;
        if (isset($instance['excluded_cats'])) : $excluded_cats = esc_attr($instance['excluded_cats']); else: $excluded_cats = ''; endif;
        if (isset($instance['default_category'])) : $default_category = esc_attr($instance['default_category']); else: $default_category = ''; endif;
        
        if (isset($instance['def_search_type'])) : $def_search_type = esc_attr($instance['def_search_type']); else: $def_search_type = ''; endif;
        
        if ($def_search_type == 'in')
            $def_search_type_in = 'checked="checked"';
        else
            $def_search_type_and = 'checked="checked"';
        
        if (isset($instance['blank_search_type'])) : 
            $blank_search_type = esc_attr($instance['blank_search_type']); 
            if ($blank_search_type == 'none')
                $blank_search_none = 'checked="checked"';
            else
                $blank_search_all = 'checked="checked"';
        else :
                $blank_search_none = 'checked="checked"';
        endif;
	
        if (isset($instance['order'])) : 
            $order = esc_attr($instance['order']); 
            if ($order == 'default')
                $order_default = 'checked="checked"';
            else
                $order_title = 'checked="checked"';
        else :
                $order_default = 'checked="checked"';
        endif;
            
        if (isset($instance['user_choice'])) : $user_choice = esc_attr($instance['user_choice']); $user_choice_checked = 'checked="checked"'; endif;
        
        ?>
            <p><label for="<?php echo $this->get_field_id('title'); ?>"><?php _e('Title:'); ?> <input class="widefat" id="<?php echo $this->get_field_id('title'); ?>" name="<?php echo $this->get_field_name('title'); ?>" type="text" value="<?php echo $title; ?>" /></label></p>
        <p><label for="<?php echo $this->get_field_id('excluded_cats'); ?>"><?php _e('Comma Seperated Excluded Category IDs:'); ?> <input class="widefat" id="<?php echo $this->get_field_id('excluded_cats'); ?>" name="<?php echo $this->get_field_name('excluded_cats'); ?>" type="text" value="<?php echo $excluded_cats; ?>" /></label></p>
        <p><input id="<?php echo $this->get_field_id('user_choice'); ?>" name="<?php echo $this->get_field_name('user_choice'); ?>" type="checkbox" <?php echo $user_choice_checked; ?> /> <label for="<?php echo $this->get_field_id('user_choice'); ?>"><?php _e('User Chooses Search Type'); ?> </label></p>
        <p><label for="<?php echo $this->get_field_id('def_search_type'); ?>"><?php _e('Default Search Type:'); ?></label></p>
        <p><input id="<?php echo $this->get_field_id('def_search_type'); ?>" name="<?php echo $this->get_field_name('def_search_type'); ?>" type="radio" value="and" <?php echo $def_search_type_and; ?> /> <?php _e('All'); ?> </p>
        <p><input id="<?php echo $this->get_field_id('def_search_type'); ?>" name="<?php echo $this->get_field_name('def_search_type'); ?>" type="radio" value="in"  <?php echo $def_search_type_in; ?> /> <?php _e('Any'); ?> </p>
        <p><label for="<?php echo $this->get_field_id('default_category'); ?>"><?php _e('Default category ID shown for blank search:'); ?> <input class="widefat" id="<?php echo $this->get_field_id('default_category'); ?>" name="<?php echo $this->get_field_name('default_category'); ?>" type="text" value="<?php echo $default_category; ?>" /></label></p>
         <p><label for="<?php echo $this->get_field_id('blank_search_type'); ?>"><?php _e('Blank Search Results:'); ?></label></p>
        <p><input id="<?php echo $this->get_field_id('blank_search_type'); ?>" name="<?php echo $this->get_field_name('blank_search_type'); ?>" type="radio" value="none" <?php echo $blank_search_none; ?> /> <?php _e('None'); ?> </p>
        <p><input id="<?php echo $this->get_field_id('blank_search_type'); ?>" name="<?php echo $this->get_field_name('blank_search_type'); ?>" type="radio" value="all"  <?php echo $blank_search_all; ?> /> <?php _e('All, or the default category ID above'); ?> </p>
        <p><label for="<?php echo $this->get_field_id('order'); ?>"><?php _e('Ordering:'); ?></label></p>
        <p><input id="<?php echo $this->get_field_id('order'); ?>" name="<?php echo $this->get_field_name('order'); ?>" type="radio" value="default" <?php echo $order_default; ?> /> <?php _e('Default'); ?> </p>
        <p><input id="<?php echo $this->get_field_id('order'); ?>" name="<?php echo $this->get_field_name('order'); ?>" type="radio" value="title"  <?php echo $order_title; ?> /> <?php _e('Title'); ?> </p>
        <?php 
    }

} // class MCSWidget

function prepare_categories($categories, $callback = 0)
{
    global $wpmm_cats;
    
    $parents = array();
    $children = array();
    
    $cat_id = NULL;
    
   if (isset($_POST['cat_id'])) : $cat_id = $_POST['cat_id']; endif; 
    
    foreach ($categories as $cat)
    {
        if (!$cat->parent || $cat->parent == $cat_id)
            $parents[] = $cat;
        else
            $children[] = $cat;
    }
    
    $html = '';
    
    foreach ($parents as $p)
    {
        if ($callback)
        $class = ' class="callback"';
    else
        $class = '';
    
    $html .= '
    <div class="select_wrapper">
        <select name="wpmm[]" '.$class.'>
        <option value="0">'.apply_filters('single_cat_title', stripslashes(str_replace('"', '', $p->name))).'</option>';
        
        foreach ($children as $c)
        {
            $selected = '';
            
            if (!empty($wpmm_cats))
            {
                $cats = explode(',', $wpmm_cats);
                
                foreach ($cats as $cat)
                {
                    if ($cat == $c->cat_ID)
                        $selected = 'selected="selected"';
                }
            }
            
            if ($p->cat_ID == $c->parent)
                $html .= '<option '.$selected.' value="'.$c->cat_ID.'"> '.apply_filters('single_cat_title', stripslashes(str_replace('"', '', $c->name))).'</option>';
        }
        
        $html .= '</select></div>';
    }
    
    if (empty($html))
        return $html;
    
    if ($callback)
        $html .='<br />';
    
    return $html;
}


/* Chained selection code */

function select_chain_list_scripts ( ) {
  wp_enqueue_script( "", path_join(WP_PLUGIN_URL, basename( dirname( __FILE__ ) )."/select-chain.js"), array( 'jquery' ) );
}
 
add_action('wp_print_scripts', 'select_chain_list_scripts');

add_action('wp_ajax_show_chain', 'show_chain_callback');
add_action('wp_ajax_nopriv_show_chain', 'show_chain_callback');

function show_chain_callback() {	

    $categories = prepare_categories(get_categories('child_of='.$_POST['cat_id'].'&orderby=name&hide_empty=1&exclude=1,'.$_POST['ex_cats']), 1);
    
    if ($_POST['cat_id'])
        print $categories;

    die();
}

?>